Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CullResult Class Reference

This stores the result of a BinCullHandler traversal: an ordered collection of CullBins, each of which holds a number of Geoms and RenderStates to be rendered in some defined order. More...

Inheritance diagram for CullResult:

List of all members.

## Public Member Functions
| addObject (CullableObject object, CullTraverser const traverser)
| Adds the indicated CullableObject to the appropriate bin.
| draw (Thread current_thread)
| Asks all the bins to draw themselves in the correct order.
| finishCull (SceneSetup scene_setup, Thread current_thread)
| Called after all the geoms have been added, this indicates that the cull process is finished for this frame and gives the bins a chance to do any post-processing (like sorting) before moving on to draw.
CullBin | getBin (int bin_index)
| Returns the CullBin associated with the indicated bin_index, or NULL if the bin_index is invalid.
CullResult | makeNext ()
| Returns a newly-allocated CullResult object that contains a copy of just the subset of the data from this CullResult object that is worth keeping around for next frame.
PandaNode | makeResultGraph ()
| Returns a special scene graph constructed to represent the results of the cull.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This stores the result of a BinCullHandler traversal: an ordered collection of CullBins, each of which holds a number of Geoms and RenderStates to be rendered in some defined order.

This is also used to keep the results of last frame's cull traversal around to make next frame's traversal of the same scene a little easier.

## Member Function Documentation

addObject | ( | CullableObject | object,
|  | CullTraverser const | traverser
| ) |  |

Adds the indicated CullableObject to the appropriate bin.

The bin becomes the owner of the object pointer, and will eventually delete it.

draw | ( | Thread | current_thread | ) |

Asks all the bins to draw themselves in the correct order.

finishCull | ( | SceneSetup | scene_setup,
|  | Thread | current_thread
| ) |  |

Called after all the geoms have been added, this indicates that the cull process is finished for this frame and gives the bins a chance to do any post-processing (like sorting) before moving on to draw.

CullBin getBin | ( | int | bin_index | ) |

Returns the CullBin associated with the indicated bin_index, or NULL if the bin_index is invalid.

If there is the first time this bin_index has been requested for this CullResult, creates a new CullBin object on the fly.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from ReferenceCount.

CullResult makeNext | ( |  | ) |

Returns a newly-allocated CullResult object that contains a copy of just the subset of the data from this CullResult object that is worth keeping around for next frame.

PandaNode makeResultGraph | ( |  | ) |

Returns a special scene graph constructed to represent the results of the cull.

This will be a hierarchy of nodes, one node for each bin, each of which will in term be a parent of a number of GeomNodes, representing the geometry drawn in each bin.

This is useful mainly for high-level debugging and abstraction tools; it should not be mistaken for the low-level cull result itself. For the low-level cull result, use draw() to efficiently draw the culled scene.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties